/*{
    "CREDIT": "franz",
    "CATEGORIES": [
        "Image Control"
    ],
    "INPUTS": [
        {
            "NAME": "inputImage",
            "TYPE": "image"
        },
                {
            "NAME": "MaskImage",
            "TYPE": "image"
        },

        { "Label": "MaskChannel", "NAME": "fx_mask","TYPE": "long", "DEFAULT": "R", "VALUES": [ "R", "G", "B" ] },

    ],

}*/
#include "MadCommon.glsl"

in vec2 mm_SurfaceCoord;
#ifdef SOFT_EDGE_1_ACTIVE
    uniform sampler2D softedge1;
#endif
#ifdef SOFT_EDGE_2_ACTIVE
    uniform sampler2D softedge2;
#endif

uniform vec4 modulationColor;
uniform float ignoreAlpha;

out vec4 out_color;

void main()
{
    vec2 U = isf_FragNormCoord;

    vec4 O = MM_SHADER_NORM_PIXEL(U);

    vec4 M = texture(MaskImage,U);
    float mask = 1.;

    if (fx_mask==0) {
        mask = M.r;
    }
    if (fx_mask==1) {
        mask = M.g;
    }
    if (fx_mask==2) {
        mask = M.b;
    }

    out_color.rgb = O.rgb;
    out_color.a = mask;
    out_color.a += ignoreAlpha;


    #ifdef SOFT_EDGE_1_ACTIVE
        out_color.rgb = out_color.rgb * texture(softedge1, mm_SurfaceCoord).r;
    #endif
    
    #ifdef SOFT_EDGE_2_ACTIVE
        out_color.rgb = out_color.rgb * texture(softedge2, mm_SurfaceCoord).r;
    #endif
}
